import java.net.*;
import java.io.*;
import java.util.*;

class Client extends Thread {
  private Socket browserSocket;

  Client(Socket socket) {
    browserSocket = socket;
  }

  public void run() {
    Socket serverSocket = null;

    BufferedReader fromBrowser = null;
    OutputStream toBrowser = null;
    PrintWriter toBrowserWriter = null;
    
    try {
      String line;
      
      fromBrowser = new BufferedReader(new InputStreamReader(browserSocket.getInputStream()));
      toBrowser = browserSocket.getOutputStream();
      toBrowserWriter = new PrintWriter(toBrowser);
      
      if ((line = fromBrowser.readLine()) != null) {
        System.out.println(line);
        StringTokenizer t = new StringTokenizer(line);
        String command = t.nextToken();        
        if (t.hasMoreTokens() && command.equals("GET")) {
          String urlString = t.nextToken();
          if (urlString.equals("/")) 
            urlString="index.html";
          if (urlString.startsWith("/"))
            urlString=urlString.substring(1,urlString.length());
	  FileInputStream fis = new FileInputStream(urlString);
          System.out.println("-->"+urlString+"("+fis.available()+")");
	  byte b[]=new byte[fis.available()];
	  fis.read(b);
 	  fis.close();
          toBrowserWriter.println("HTTP/1.0 200 OK\nContent-Type: text/html\n");
	  toBrowserWriter.println(new String(b));
	  toBrowserWriter.flush();
        }
      }
    } 
    catch (Exception e) {
      if (toBrowser != null)
	try {
          toBrowserWriter.println("HTTP/1.0 404 Not Found\nContent-Type: text/html\n");
          toBrowserWriter.println("<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>404 Not Found</H1><P>"+e.toString()+"</BODY></HTML>");
          toBrowserWriter.flush();
	} catch (Exception f) {}
    }
    finally {
      if (fromBrowser != null)
	try {fromBrowser.close();} catch (Exception e) {}
      if (toBrowserWriter != null)
	try {toBrowserWriter.close();} catch (Exception e) {}
      try {browserSocket.close();} catch (Exception e) {}
    }
  }
}


class Httpd {
  private static int port;
  
  private static void usage() {
    System.err.println("usage: java httpd <port>");
    System.exit(1);
  }
	
  public static void main(String[] args) {
    if (args.length==1) {
      try {
        port = Integer.parseInt(args[0]);
        try {
          ServerSocket server = new ServerSocket(port);



          for (;;) {
   	    Socket s = server.accept();
	    Client client = new Client(s);
	    client.start();
          }

          
        } catch (Exception e) {
          System.err.println("Erreur: " + e);
          System.exit(1);
        }
      } catch (NumberFormatException e) {
        usage();
      }
    }
    else
      usage();
  }
}
