import java.io.*;
import java.net.*;
import java.util.*;

class Middle extends Thread {
  private static int port;

  Socket browserSocket;	
  Middle(Socket theSocket) {
    browserSocket=theSocket;
  }
   
  public void run() {
    BufferedReader fromBrowser=null;
    PrintWriter toBrowser=null;
  	
    try {
      fromBrowser=new BufferedReader(new InputStreamReader(browserSocket.getInputStream()));
      toBrowser=new PrintWriter(browserSocket.getOutputStream());
      String line,pageArgs="",providerArgs="";
      if ((line=fromBrowser.readLine())!=null) {
    	
        StringTokenizer myStringTokenizer=new StringTokenizer(line);
        String theCommand=myStringTokenizer.nextToken();
        if (myStringTokenizer.hasMoreTokens() && theCommand.equals("GET")) {
          String theRequestedUrl=myStringTokenizer.nextToken();
          if (theRequestedUrl.startsWith("/"))
            theRequestedUrl="http://"+browserSocket.getInetAddress().getHostAddress()+theRequestedUrl;
          if (theRequestedUrl.indexOf("?")>-1) {
            pageArgs=theRequestedUrl.substring(theRequestedUrl.indexOf("?")+1,theRequestedUrl.length());
            theRequestedUrl=theRequestedUrl.substring(0,theRequestedUrl.indexOf("?"));
          }

          URL hostUrl=new URL(theRequestedUrl);
          if (theRequestedUrl.toUpperCase().endsWith(".MIDDLE")) {
        
            BufferedReader fromHost=new BufferedReader(new InputStreamReader(hostUrl.openStream()));
            toBrowser.println("HTTP/1.0 200 OK\nContent-Type:text/html\n");
            while ((line=fromHost.readLine())!=null) {
              int p,q;
      	      String result="";                        
              while ((p=line.indexOf("<!MIDDLE="))!=-1) {
                String theRequestedProvider="";              	
                if ((q=line.indexOf(">",p))!=-1) {
                  theRequestedProvider=line.substring(p+9,q);
                  if (theRequestedProvider.indexOf("?")>-1) {
                    providerArgs=theRequestedProvider.substring(theRequestedProvider.indexOf("?")+1,theRequestedProvider.length());
                    theRequestedProvider=theRequestedProvider.substring(0,theRequestedProvider.indexOf("?"));
                  }
                }
                
                FileInputStream fromFile=new FileInputStream(theRequestedProvider);
                ObjectInputStream theObjectInputStream=new ObjectInputStream(fromFile);
                MiddleProvider provider=(MiddleProvider)theObjectInputStream.readObject();
                fromFile.close();
              
                result=line.substring(0,p)+result+provider.get(new String[] { pageArgs, providerArgs });
  	        line=line.substring(++q,line.length());
  	      }
              result=result+line;
              toBrowser.println(result);
            }
            fromHost.close();            
          }
          else {
            InputStream fromHost=hostUrl.openStream();
            byte buffer[]=new byte[fromHost.available()];
            fromHost.read(buffer);
            toBrowser.println(new String(buffer));
            fromHost.close();
          }
          toBrowser.flush();
          toBrowser.close();
        }
      }
    }
    catch (Exception e) {
      try {
        toBrowser.println("HTTP/1.0 404 Not Found\nContent-Type: text/html\n");
        toBrowser.println("<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>404 Not Found</H1><P>"+e.toString()+"</BODY></HTML>");
        toBrowser.flush();
        toBrowser.close();
      }
      catch (Exception f) {};   
    }
  }

  private static void usage() {
    System.err.println("usage: java Middle <port>");
    System.exit(1);
  }  	

  public static void main(String args[]) {
    if (args.length==1) {
      port = Integer.parseInt(args[0]);
      try {
        ServerSocket serverSocket = new ServerSocket(port);
        for (;;) {
          Socket browserSocket=serverSocket.accept();
          new Middle(browserSocket).start();
        }
      }
      catch (Exception e) {
        e.printStackTrace();
      }
    }
    else
      usage(); 
  }
}
